// Copyright © VNG Realisatie 2023
// Licensed under the EUPL

package rest

import (
	"context"
	"fmt"
	"time"

	"gitlab.com/commonground/nlx/fsc-nlx/manager/apps/int/query"
	"gitlab.com/commonground/nlx/fsc-nlx/manager/ports/int/rest/api/models"
	api "gitlab.com/commonground/nlx/fsc-nlx/manager/ports/int/rest/api/server"
	"gitlab.com/commonground/nlx/fsc-nlx/txlog-api/domain/record"
)

// nolint:gocritic // hugeParam: we have to conform to the interface generated by the oas generator
func (s *Server) GetLogs(ctx context.Context, req api.GetLogsRequestObject) (api.GetLogsResponseObject, error) {
	s.logger.Info("rest request ListRecords")

	sortOrder := query.SortOrderAscending

	if req.Params.SortOrder != nil && *req.Params.SortOrder == models.SORTORDERDESCENDING {
		sortOrder = query.SortOrderDescending
	}

	var (
		startID          string
		dataSourcePeerID string
		limit            uint32
	)

	if req.Params.Cursor != nil {
		startID = *req.Params.Cursor
	}

	if req.Params.Limit != nil {
		limit = *req.Params.Limit
	}

	if req.Params.DataSourcePeerId != nil {
		dataSourcePeerID = *req.Params.DataSourcePeerId
	}

	records, err := s.app.Queries.GetTXLogRecords.Handle(ctx, &query.ListTXLogRecordsHandlerArgs{
		Pagination: &query.Pagination{
			StartID:   startID,
			Limit:     limit,
			SortOrder: sortOrder,
		},
		Filters:          mapRestToQueryFilters(&req.Params),
		DataSourcePeerID: dataSourcePeerID,
	})
	if err != nil {
		s.logger.Error("error getting tx log records from query", err)
		return nil, err
	}

	response, err := mapQueryToRestLogs(records)
	if err != nil {
		s.logger.Error("unable to convert query model to api model", err)
		return nil, err
	}

	return api.GetLogs200JSONResponse{
		Records: response,
		Pagination: models.PaginationResult{
			NextCursor: getNextLogCursor(records),
		},
	}, nil
}

func mapQueryToRestLogs(records []*query.TXLogRecord) ([]models.LogRecord, error) {
	recs := make([]models.LogRecord, len(records))

	for i, r := range records {
		data, err := mapSourceAndDirection(r.Source, r.Destination)
		if err != nil {
			return nil, err
		}

		recs[i] = models.LogRecord{
			TransactionId: r.TransactionID,
			GrantHash:     r.GrantHash,
			ServiceName:   r.ServiceName,
			Direction:     mapDirection(r.Direction),
			Source:        data.Source,
			Destination:   data.Destination,
			CreatedAt:     r.CreatedAt.Unix(),
		}
	}

	return recs, nil
}

func mapSourceAndDirection(source, destination interface{}) (*models.LogRecord, error) {
	data := &models.LogRecord{}

	switch s := source.(type) {
	case *query.TXLogRecordSource:
		err := data.Source.FromSource(models.Source{
			Type:         models.TYPESOURCE,
			OutwayPeerId: s.OutwayPeerID,
		})
		if err != nil {
			return nil, err
		}

	case *query.TXLogRecordDelegatedSource:
		err := data.Source.FromSourceDelegated(models.SourceDelegated{
			Type:            models.TYPEDELEGATEDSOURCE,
			OutwayPeerId:    s.OutwayPeerID,
			DelegatorPeerId: s.DelegatorPeerID,
		})
		if err != nil {
			return nil, err
		}

	default:
		return nil, fmt.Errorf("unknown source type: %T", s)
	}

	switch d := destination.(type) {
	case *query.TXLogRecordDestination:
		err := data.Destination.FromDestination(models.Destination{
			Type:          models.TYPEDESTINATION,
			ServicePeerId: d.ServicePeerID,
		})
		if err != nil {
			return nil, err
		}

	case *query.TXLogRecordDelegatedDestination:
		err := data.Destination.FromDestinationDelegated(models.DestinationDelegated{
			Type:            models.TYPEDELEGATEDDESTINATION,
			ServicePeerId:   d.ServicePeerID,
			DelegatorPeerId: d.DelegatorPeerID,
		})
		if err != nil {
			return nil, err
		}

	default:
		return nil, fmt.Errorf("unknown destination type: %T", d)
	}

	return data, nil
}

func mapDirection(d record.Direction) models.DirectionType {
	switch d {
	case record.DirectionIn:
		return models.DIRECTIONINCOMING
	case record.DirectionOut:
		return models.DIRECTIONOUTGOING
	default:
		return models.DIRECTIONINCOMING
	}
}

func getNextLogCursor(records []*query.TXLogRecord) string {
	if len(records) == 0 {
		return ""
	}

	return records[len(records)-1].TransactionID
}

//nolint:gocyclo // complex mapping due to use of arrays in parameters and the way openapi generator handles this
func mapRestToQueryFilters(params *models.GetLogsParams) []*query.Filter {
	filters := make([]*query.Filter, 0)

	if params.GrantHash != nil {
		for _, g := range *params.GrantHash {
			filters = append(filters, &query.Filter{
				GrantHash: g,
			})
		}
	}

	if params.ServiceName != nil {
		for _, s := range *params.ServiceName {
			filters = append(filters, &query.Filter{
				ServiceName: s,
			})
		}
	}

	if params.TransactionId != nil {
		for _, t := range *params.TransactionId {
			filters = append(filters, &query.Filter{
				TransactionID: t,
			})
		}
	}

	if params.PeerId != nil {
		for _, p := range *params.PeerId {
			filters = append(filters, &query.Filter{
				PeerID: p,
			})
		}
	}

	if params.Before != nil || params.After != nil {
		p := &query.Period{}

		if params.Before != nil {
			p.End = time.Unix(*params.Before, 0)
		}

		if params.After != nil {
			p.Start = time.Unix(*params.After, 0)
		}

		filters = append(filters, &query.Filter{
			Period: p,
		})
	}

	return filters
}
